const dw.version= "0.1.6.2"

long dw.CallerProcAddr

string dw.agentName=""'appTitle

dw.ver export "Gibt die Versionsnummer der Include als String zurck." {return dw.version}

dw.ip export "Liefert die WAN-IP zurck." {return dw.get("http://ip.mxii.com")}

dw.get(string url,target) export "dw.get(''http://url'') gibt den downgeloadeten Inhalt der url als String zurck. dw.get(''http://url'',''Zieldatei'') gibt die Anzahl der downgeloadeten Bytes als Long zurck. Der downgeloadete Inhalt landet dann in der Zieldatei." { 

	select pcount
	
		caseof 1 : return dw.DownloadFile(url,"",dw.CallerProcAddr)
		
		caseof 2 : return dw.DownloadFile(url,target,dw.CallerProcAddr)
			
	endselect

	return ""	
}

dw.checkinternet export "Experimentell: Prft ob eine Internetverbindung hergestellt ist." {

	bool isnet=false
	
	long dllh=usedll("wininet.dll")
	
	casenot dllh : return false
	
	long hinet=external("wininet.dll","InternetOpenA",0,0,nul,nul,0);
	
	if hinet {
	
		isnet=true
		external("wininet.dll","InternetCloseHandle",hInet)
		
	}
	
	freedll dllh

	return isnet	
}

dw.checkspeed export "Gibt den http-downloadspeed in bytes/sekunde als float zurck. Hierbei handelt es sich um eine Schtzung und trotzdem gibt die Funktion fr einfache Zeitberechnungen einen guten Richtwert aus. Die Funktion gibt eher geringeren statt einen zu hohen Wert aus." {

	casenot dw.checkinternet() : return 0
	
	long __int_dwspd=gettickcount

	dw.get("http://ip.mxii.com/speed.get")
	
	__int_dwspd=1000/((&gettickcount-__int_dwspd)/150000)

	return __int_dwspd
}


					/*
                                        ######## INTERNAL FUNCTIONS ########
                                       					  */


dw.DownloadFile(string url,destinationFileName,long downloadCallerProc) noexport { // wird nur intern verwendet, Handler ist dw.get(..

	long oel=set("ErrorLevel",-1)
	long ofm=set("FileMode",2)

	string content=""
	
	long dllh=usedll("wininet.dll")
	
	ifnot dllh {
	
		set("FileMode",ofm)
		set("ErrorLevel",oel)
		return ""
		
	}

	long hInet = external("wininet.dll","InternetOpenA",addr(dw.agentName),,,,)
	
	ifnot hInet {
	
		freedll dllh
		set("FileMode",ofm)
		set("ErrorLevel",oel)
		return ""
		
	}

	long hFile = external("wininet.dll","InternetOpenUrlA",hInet,addr(url),,,$80000000,);
	
	ifnot hFile {
	
		external("wininet.dll","InternetCloseHandle",hInet)	
		freedll dllh
		set("FileMode",ofm)
		set("ErrorLevel",oel)
		return ""
		
	}

	mem buf=16384

	case downloadCallerProc : call(downloadCallerProc,-1)
	
	long bytesread,accbytesread,i

	do {

		external("wininet.dll","InternetReadFile",hFile,buf,16384,addr(bytesread))

		if bytesread>0 {

			content=content+char$(buf,0,bytesread)
				
			accbytesread=accbytesread+bytesread
			
			if downloadCallerProc {
			
				ifnot call(downloadCallerProc,accbytesread) {

					content=""
					break
				
				}
				
			}
			
			//

		} else {break}

	}
	
	case downloadCallerProc : call(downloadCallerProc,-2)

	external("wininet.dll","InternetCloseHandle",hFile)
	external("wininet.dll","InternetCloseHandle",hInet)

	dispose buf
	
	freedll dllh

	set("FileMode",ofm)
	set("ErrorLevel",oel)

	return content
}